Subject: Re: [netmod] Feedback on Self-Describing Data Object Tags in YANG Data Models

From: Qin Wu <[email-masked]>
Date: Thu, 14 Apr 2022 06:09:04 +0000

Thanks Joe, I believe we are on the same page now, I am working on the example at the instance level now, will add them to the appendix. 
Thanks again for good comment.

-Qin
-----邮件原件-----
发件人: Joe Clarke (jclarke) [mailto:jclarke=[email-masked]] 
发送时间: 2022年4月14日 5:09
收件人: Qin Wu <[email-masked]>; [email-masked]
主题: Re: Feedback on Self-Describing Data Object Tags in YANG Data Models

Thanks, Qin.  See below.  I had to get back into the tags groove.

On 4/10/22 06:49, Qin Wu wrote:
> Hi, Joe:
> Sorry for late follow up. Thank for your comment, please see my reply below.
> -----邮件原件-----
>> 发件人: netmod [mailto:[email-masked]] 代表 Joe Clarke (jclarke)
>> 发送时间: 2022年3月22日 18:12
>> 收件人: [email-masked]
>> 主题: [netmod] Feedback on Self-Describing Data Object Tags in YANG 
>> Data Models Rob commented at the mic during the 113 meeting that using self-describing tags for specific data instances may be a design of this solution, but the text doesn't state that.
> [Qin] Note that in ietf-data-object-tags, we use 'name' to identify 
> each data object, Therefore I can self-describing tag can be used 
> either for specific data instance or schema node, correct me if I am wrong.

You do, yes.  I think what Rob and I were requesting is an example that shows why I might use these at the instance level.

>
> Secondly, in this draft, we define three category of self-describing 
> tags: OPM tag, metric type tag and multi-source tag.
> After having a second thinking of your suggestion and Rob's, it seems 
> OPM tag and metric type tag might be more suited for being used in the 
> schema level Since when the model is defined in the design stage, we may have already known it. Please also see above clarification on how I understand how self-describing tag is used for specific data instance.

Not sure about the design phase.  I was thinking more at the runtime level I'd know that a given instance of an interface, tunnel, etc. has some significance to which I'd assign a user: tag.  I may or may not know this at design-time.

>
> As for multi-source tag, I sort of agree with you it can be used at 
> the data instance level, but I am not sure it cover the use case mentioned below.
>
>> To add to the request to provide such text, it would be useful to have an example showing this.
>> One potential use I can think of for this is to use user tags to self-describe the instance of an interface to be "critical" or high-priority for purposes of more aggressive monitoring/telemetry subscriptions, etc.
>  [Qin] Thanks Joe for proposed use, See above clarification, I am not sure this case has been covered by one of self-describing tag described above.
> maybe we can expand multi-source tag or introduce a new self-describing tag to cover your use case, but one thing I am not sure whether I can enumerate all other use cases in this self-describing tags draft. Comments,suggestions and input?

I don't think you need to describe all use cases.  I think one showing an instance may be sufficient.  I was re-reading your tunnel example. 
Let's say I have a tunnel instance "foo" that corresponds to customer example.com.  Could I not create user:customer_example_com tags on instances of the property and metrics (as well as related objects) to help me identify data for that customer?

Joe